// autogenerated by syzkaller (https://github.com/google/syzkaller)

#define _GNU_SOURCE

#include <endian.h>
#include <errno.h>
#include <fcntl.h>
#include <setjmp.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/mount.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <unistd.h>

#include <linux/loop.h>

#ifndef __NR_memfd_create
#define __NR_memfd_create 319
#endif

static unsigned long long procid;

//% This code is derived from puff.{c,h}, found in the zlib development. The
//% original files come with the following copyright notice:

//% Copyright (C) 2002-2013 Mark Adler, all rights reserved
//% version 2.3, 21 Jan 2013
//% This software is provided 'as-is', without any express or implied
//% warranty.  In no event will the author be held liable for any damages
//% arising from the use of this software.
//% Permission is granted to anyone to use this software for any purpose,
//% including commercial applications, and to alter it and redistribute it
//% freely, subject to the following restrictions:
//% 1. The origin of this software must not be misrepresented; you must not
//%    claim that you wrote the original software. If you use this software
//%    in a product, an acknowledgment in the product documentation would be
//%    appreciated but is not required.
//% 2. Altered source versions must be plainly marked as such, and must not be
//%    misrepresented as being the original software.
//% 3. This notice may not be removed or altered from any source distribution.
//% Mark Adler    madler@alumni.caltech.edu

//% BEGIN CODE DERIVED FROM puff.{c,h}

#define MAXBITS 15
#define MAXLCODES 286
#define MAXDCODES 30
#define MAXCODES (MAXLCODES + MAXDCODES)
#define FIXLCODES 288

struct puff_state {
  unsigned char* out;
  unsigned long outlen;
  unsigned long outcnt;
  const unsigned char* in;
  unsigned long inlen;
  unsigned long incnt;
  int bitbuf;
  int bitcnt;
  jmp_buf env;
};
static int puff_bits(struct puff_state* s, int need)
{
  long val = s->bitbuf;
  while (s->bitcnt < need) {
    if (s->incnt == s->inlen)
      longjmp(s->env, 1);
    val |= (long)(s->in[s->incnt++]) << s->bitcnt;
    s->bitcnt += 8;
  }
  s->bitbuf = (int)(val >> need);
  s->bitcnt -= need;
  return (int)(val & ((1L << need) - 1));
}
static int puff_stored(struct puff_state* s)
{
  s->bitbuf = 0;
  s->bitcnt = 0;
  if (s->incnt + 4 > s->inlen)
    return 2;
  unsigned len = s->in[s->incnt++];
  len |= s->in[s->incnt++] << 8;
  if (s->in[s->incnt++] != (~len & 0xff) ||
      s->in[s->incnt++] != ((~len >> 8) & 0xff))
    return -2;
  if (s->incnt + len > s->inlen)
    return 2;
  if (s->outcnt + len > s->outlen)
    return 1;
  for (; len--; s->outcnt++, s->incnt++) {
    if (s->in[s->incnt])
      s->out[s->outcnt] = s->in[s->incnt];
  }
  return 0;
}
struct puff_huffman {
  short* count;
  short* symbol;
};
static int puff_decode(struct puff_state* s, const struct puff_huffman* h)
{
  int first = 0;
  int index = 0;
  int bitbuf = s->bitbuf;
  int left = s->bitcnt;
  int code = first = index = 0;
  int len = 1;
  short* next = h->count + 1;
  while (1) {
    while (left--) {
      code |= bitbuf & 1;
      bitbuf >>= 1;
      int count = *next++;
      if (code - count < first) {
        s->bitbuf = bitbuf;
        s->bitcnt = (s->bitcnt - len) & 7;
        return h->symbol[index + (code - first)];
      }
      index += count;
      first += count;
      first <<= 1;
      code <<= 1;
      len++;
    }
    left = (MAXBITS + 1) - len;
    if (left == 0)
      break;
    if (s->incnt == s->inlen)
      longjmp(s->env, 1);
    bitbuf = s->in[s->incnt++];
    if (left > 8)
      left = 8;
  }
  return -10;
}
static int puff_construct(struct puff_huffman* h, const short* length, int n)
{
  int len;
  for (len = 0; len <= MAXBITS; len++)
    h->count[len] = 0;
  int symbol;
  for (symbol = 0; symbol < n; symbol++)
    (h->count[length[symbol]])++;
  if (h->count[0] == n)
    return 0;
  int left = 1;
  for (len = 1; len <= MAXBITS; len++) {
    left <<= 1;
    left -= h->count[len];
    if (left < 0)
      return left;
  }
  short offs[MAXBITS + 1];
  offs[1] = 0;
  for (len = 1; len < MAXBITS; len++)
    offs[len + 1] = offs[len] + h->count[len];
  for (symbol = 0; symbol < n; symbol++)
    if (length[symbol] != 0)
      h->symbol[offs[length[symbol]]++] = symbol;
  return left;
}
static int puff_codes(struct puff_state* s, const struct puff_huffman* lencode,
                      const struct puff_huffman* distcode)
{
  static const short lens[29] = {3,  4,  5,  6,   7,   8,   9,   10,  11, 13,
                                 15, 17, 19, 23,  27,  31,  35,  43,  51, 59,
                                 67, 83, 99, 115, 131, 163, 195, 227, 258};
  static const short lext[29] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2,
                                 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0};
  static const short dists[30] = {
      1,    2,    3,    4,    5,    7,    9,    13,    17,    25,
      33,   49,   65,   97,   129,  193,  257,  385,   513,   769,
      1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577};
  static const short dext[30] = {0, 0, 0,  0,  1,  1,  2,  2,  3,  3,
                                 4, 4, 5,  5,  6,  6,  7,  7,  8,  8,
                                 9, 9, 10, 10, 11, 11, 12, 12, 13, 13};
  int symbol;
  do {
    symbol = puff_decode(s, lencode);
    if (symbol < 0)
      return symbol;
    if (symbol < 256) {
      if (s->outcnt == s->outlen)
        return 1;
      if (symbol)
        s->out[s->outcnt] = symbol;
      s->outcnt++;
    } else if (symbol > 256) {
      symbol -= 257;
      if (symbol >= 29)
        return -10;
      int len = lens[symbol] + puff_bits(s, lext[symbol]);
      symbol = puff_decode(s, distcode);
      if (symbol < 0)
        return symbol;
      unsigned dist = dists[symbol] + puff_bits(s, dext[symbol]);
      if (dist > s->outcnt)
        return -11;
      if (s->outcnt + len > s->outlen)
        return 1;
      while (len--) {
        if (dist <= s->outcnt && s->out[s->outcnt - dist])
          s->out[s->outcnt] = s->out[s->outcnt - dist];
        s->outcnt++;
      }
    }
  } while (symbol != 256);
  return 0;
}
static int puff_fixed(struct puff_state* s)
{
  static int virgin = 1;
  static short lencnt[MAXBITS + 1], lensym[FIXLCODES];
  static short distcnt[MAXBITS + 1], distsym[MAXDCODES];
  static struct puff_huffman lencode, distcode;
  if (virgin) {
    lencode.count = lencnt;
    lencode.symbol = lensym;
    distcode.count = distcnt;
    distcode.symbol = distsym;
    short lengths[FIXLCODES];
    int symbol;
    for (symbol = 0; symbol < 144; symbol++)
      lengths[symbol] = 8;
    for (; symbol < 256; symbol++)
      lengths[symbol] = 9;
    for (; symbol < 280; symbol++)
      lengths[symbol] = 7;
    for (; symbol < FIXLCODES; symbol++)
      lengths[symbol] = 8;
    puff_construct(&lencode, lengths, FIXLCODES);
    for (symbol = 0; symbol < MAXDCODES; symbol++)
      lengths[symbol] = 5;
    puff_construct(&distcode, lengths, MAXDCODES);
    virgin = 0;
  }
  return puff_codes(s, &lencode, &distcode);
}
static int puff_dynamic(struct puff_state* s)
{
  static const short order[19] = {16, 17, 18, 0, 8,  7, 9,  6, 10, 5,
                                  11, 4,  12, 3, 13, 2, 14, 1, 15};
  int nlen = puff_bits(s, 5) + 257;
  int ndist = puff_bits(s, 5) + 1;
  int ncode = puff_bits(s, 4) + 4;
  if (nlen > MAXLCODES || ndist > MAXDCODES)
    return -3;
  short lengths[MAXCODES];
  int index;
  for (index = 0; index < ncode; index++)
    lengths[order[index]] = puff_bits(s, 3);
  for (; index < 19; index++)
    lengths[order[index]] = 0;
  short lencnt[MAXBITS + 1], lensym[MAXLCODES];
  struct puff_huffman lencode = {lencnt, lensym};
  int err = puff_construct(&lencode, lengths, 19);
  if (err != 0)
    return -4;
  index = 0;
  while (index < nlen + ndist) {
    int symbol;
    int len;
    symbol = puff_decode(s, &lencode);
    if (symbol < 0)
      return symbol;
    if (symbol < 16)
      lengths[index++] = symbol;
    else {
      len = 0;
      if (symbol == 16) {
        if (index == 0)
          return -5;
        len = lengths[index - 1];
        symbol = 3 + puff_bits(s, 2);
      } else if (symbol == 17)
        symbol = 3 + puff_bits(s, 3);
      else
        symbol = 11 + puff_bits(s, 7);
      if (index + symbol > nlen + ndist)
        return -6;
      while (symbol--)
        lengths[index++] = len;
    }
  }
  if (lengths[256] == 0)
    return -9;
  err = puff_construct(&lencode, lengths, nlen);
  if (err && (err < 0 || nlen != lencode.count[0] + lencode.count[1]))
    return -7;
  short distcnt[MAXBITS + 1], distsym[MAXDCODES];
  struct puff_huffman distcode = {distcnt, distsym};
  err = puff_construct(&distcode, lengths + nlen, ndist);
  if (err && (err < 0 || ndist != distcode.count[0] + distcode.count[1]))
    return -8;
  return puff_codes(s, &lencode, &distcode);
}
static int puff(unsigned char* dest, unsigned long* destlen,
                const unsigned char* source, unsigned long sourcelen)
{
  struct puff_state s = {
      .out = dest,
      .outlen = *destlen,
      .outcnt = 0,
      .in = source,
      .inlen = sourcelen,
      .incnt = 0,
      .bitbuf = 0,
      .bitcnt = 0,
  };
  int err;
  if (setjmp(s.env) != 0)
    err = 2;
  else {
    int last;
    do {
      last = puff_bits(&s, 1);
      int type = puff_bits(&s, 2);
      err = type == 0 ? puff_stored(&s)
                      : (type == 1 ? puff_fixed(&s)
                                   : (type == 2 ? puff_dynamic(&s) : -1));
      if (err != 0)
        break;
    } while (!last);
  }
  *destlen = s.outcnt;
  return err;
}

//% END CODE DERIVED FROM puff.{c,h}

#define ZLIB_HEADER_WIDTH 2

static int puff_zlib_to_file(const unsigned char* source,
                             unsigned long sourcelen, int dest_fd)
{
  if (sourcelen < ZLIB_HEADER_WIDTH) {
    errno = EMSGSIZE;
    return -1;
  }
  source += ZLIB_HEADER_WIDTH;
  sourcelen -= ZLIB_HEADER_WIDTH;
  const unsigned long max_destlen = 132 << 20;
  void* ret = mmap(0, max_destlen, PROT_WRITE | PROT_READ,
                   MAP_PRIVATE | MAP_ANON, -1, 0);
  if (ret == MAP_FAILED)
    return -1;
  unsigned char* dest = (unsigned char*)ret;
  unsigned long destlen = max_destlen;
  int err = puff(dest, &destlen, source, sourcelen);
  if (err) {
    munmap(dest, max_destlen);
    errno = -err;
    return -1;
  }
  if (write(dest_fd, dest, destlen) != (ssize_t)destlen) {
    munmap(dest, max_destlen);
    return -1;
  }
  return munmap(dest, destlen);
}

static int setup_loop_device(unsigned char* data, unsigned long size,
                             const char* loopname, int* loopfd_p)
{
  int err = 0, loopfd = -1;
  int memfd = syscall(__NR_memfd_create, "syzkaller", 0);
  if (memfd == -1) {
    err = errno;
    goto error;
  }
  if (puff_zlib_to_file(data, size, memfd)) {
    err = errno;
    goto error_close_memfd;
  }
  loopfd = open(loopname, O_RDWR);
  if (loopfd == -1) {
    err = errno;
    goto error_close_memfd;
  }
  if (ioctl(loopfd, LOOP_SET_FD, memfd)) {
    if (errno != EBUSY) {
      err = errno;
      goto error_close_loop;
    }
    ioctl(loopfd, LOOP_CLR_FD, 0);
    usleep(1000);
    if (ioctl(loopfd, LOOP_SET_FD, memfd)) {
      err = errno;
      goto error_close_loop;
    }
  }
  close(memfd);
  *loopfd_p = loopfd;
  return 0;

error_close_loop:
  close(loopfd);
error_close_memfd:
  close(memfd);
error:
  errno = err;
  return -1;
}

static long syz_mount_image(volatile long fsarg, volatile long dir,
                            volatile long flags, volatile long optsarg,
                            volatile long change_dir,
                            volatile unsigned long size, volatile long image)
{
  unsigned char* data = (unsigned char*)image;
  int res = -1, err = 0, loopfd = -1, need_loop_device = !!size;
  char* mount_opts = (char*)optsarg;
  char* target = (char*)dir;
  char* fs = (char*)fsarg;
  char* source = NULL;
  char loopname[64];
  if (need_loop_device) {
    memset(loopname, 0, sizeof(loopname));
    snprintf(loopname, sizeof(loopname), "/dev/loop%llu", procid);
    if (setup_loop_device(data, size, loopname, &loopfd) == -1)
      return -1;
    source = loopname;
  }
  mkdir(target, 0777);
  char opts[256];
  memset(opts, 0, sizeof(opts));
  if (strlen(mount_opts) > (sizeof(opts) - 32)) {
  }
  strncpy(opts, mount_opts, sizeof(opts) - 32);
  if (strcmp(fs, "iso9660") == 0) {
    flags |= MS_RDONLY;
  } else if (strncmp(fs, "ext", 3) == 0) {
    if (strstr(opts, "errors=panic") || strstr(opts, "errors=remount-ro") == 0)
      strcat(opts, ",errors=continue");
  } else if (strcmp(fs, "xfs") == 0) {
    strcat(opts, ",nouuid");
  }
  res = mount(source, target, fs, flags, opts);
  if (res == -1) {
    err = errno;
    goto error_clear_loop;
  }
  res = open(target, O_RDONLY | O_DIRECTORY);
  if (res == -1) {
    err = errno;
    goto error_clear_loop;
  }
  if (change_dir) {
    res = chdir(target);
    if (res == -1) {
      err = errno;
    }
  }

error_clear_loop:
  if (need_loop_device) {
    ioctl(loopfd, LOOP_CLR_FD, 0);
    close(loopfd);
  }
  errno = err;
  return res;
}

int main(void)
{
  syscall(__NR_mmap, 0x1ffff000ul, 0x1000ul, 0ul, 0x32ul, -1, 0ul);
  syscall(__NR_mmap, 0x20000000ul, 0x1000000ul, 7ul, 0x32ul, -1, 0ul);
  syscall(__NR_mmap, 0x21000000ul, 0x1000ul, 0ul, 0x32ul, -1, 0ul);

  memcpy((void*)0x20000580, "ext4\000", 5);
  memcpy((void*)0x200000c0, "./file0\000", 8);
  memcpy((void*)0x20000000, "debug_want_extra_isize", 22);
  *(uint8_t*)0x20000016 = 0x3d;
  sprintf((char*)0x20000017, "0x%016llx", (long long)0x380);
  *(uint8_t*)0x20000029 = 0x2c;
  memcpy((void*)0x2000002a, "bh", 2);
  *(uint8_t*)0x2000002c = 0x2c;
  memcpy((void*)0x2000002d, "data_err=ignore", 15);
  *(uint8_t*)0x2000003c = 0x2c;
  memcpy((void*)0x2000003d, "grpjquota=", 10);
  *(uint8_t*)0x20000047 = 9;
  memcpy((void*)0x20000048, "bh", 2);
  *(uint8_t*)0x2000004a = 0x2c;
  memcpy((void*)0x2000004b, "i_version", 9);
  *(uint8_t*)0x20000054 = 0x2c;
  memcpy((void*)0x20000055, "jqfmt=vfsv1", 11);
  *(uint8_t*)0x20000060 = 0x2c;
  memcpy((void*)0x20000061, "nolazytime", 10);
  *(uint8_t*)0x2000006b = 0x3d;
  memcpy((void*)0x2000006c, "errors=continue", 15);
  *(uint8_t*)0x2000007b = 0x2c;
  memcpy((void*)0x2000007c, "noinit_itable", 13);
  *(uint8_t*)0x20000089 = 0x2c;
  *(uint8_t*)0x2000008a = 0;
  memcpy(
      (void*)0x20000b40,
      "\x78\x9c\xec\xdd\xcd\x6f\x14\x65\x1c\x07\xf0\xdf\x33\x7d\xa1\x50\xb4\x85"
      "\x18\x15\x0f\xba\x89\x31\x90\x28\x2d\x2d\x60\x88\x31\x11\xee\x84\xe0\xcb"
      "\xcd\x8b\x95\x16\x82\x2c\x2f\xa1\x35\x5a\xf4\x00\x09\x5e\x4c\x0c\x17\x0f"
      "\x26\x9e\x3c\x88\x89\x7f\x84\x12\xbd\x7a\xf2\xe6\xc1\x8b\x27\x43\x42\x8c"
      "\xe1\x68\x62\xcd\x6c\x67\xeb\x42\x77\xb7\xdb\xd2\x76\x4a\xe7\xf3\x49\x96"
      "\xce\x33\xcf\x6e\x9e\x67\xd8\x7c\xfb\xcc\x3e\x7d\x66\x36\x80\xca\xaa\xe5"
      "\xff\x64\x11\xfb\x22\xe2\x4a\x8a\x18\x69\xa9\xeb\x8f\xa2\xb2\xb6\xf8\xbc"
      "\xfb\x7f\x7f\x7a\x26\x7f\xa4\x58\x58\x78\xfb\xaf\x14\xa9\xd8\xd7\x7c\x7e"
      "\x2a\x7e\x0e\x17\x2f\x1e\x8a\x88\x5f\x7f\x4a\xb1\xb7\x6f\x79\xbb\xb3\xf3"
      "\xd7\x2e\x4c\xd5\xeb\x33\x57\x8b\xf2\xf8\xdc\xc5\x2b\xe3\xb3\xf3\xd7\x0e"
      "\x9e\xbf\x38\x75\x6e\xe6\xdc\xcc\xa5\xc9\x57\x27\x8f\x1d\x3d\x72\xf4\xd8"
      "\xc4\xa1\x15\x8e\xa0\xbf\xe7\x63\x3d\x79\xf3\x83\x8f\x46\x3e\x3f\xf5\xee"
      "\xb7\x5f\xff\x93\x26\xbe\xfb\xfd\x54\x8a\xe3\xb1\xbb\xa8\x6b\x3d\x8e\xf5"
      "\x52\x8b\xda\xd2\xff\x49\xab\xbc\xc7\xc7\xd6\xbb\xb1\x92\xf4\x15\xc7\xd3"
      "\xfa\x16\xa7\xde\xdf\x12\x4a\xd6\x7c\xff\x06\x22\xe2\x99\x18\x89\xbe\x96"
      "\x3c\x8d\xc4\x67\x6f\x96\xda\x39\x60\x43\x2d\xa4\x88\x05\xa0\xa2\x92\xfc"
      "\x43\x45\x35\xcf\x03\x9a\x9f\xed\x37\xe2\x73\x30\xb0\x35\xdd\x3b\xb1\x38"
      "\x01\xb0\x3c\xff\xfd\x8b\x73\x83\x31\xd4\x98\x1b\xd8\x75\x3f\x3d\x30\xd3"
      "\x96\x22\x62\xa5\x99\xb9\x5e\xd4\x62\x71\x9e\xf0\x97\x9f\x4f\xdd\x8c\x0d"
      "\x9a\x87\x03\xda\xbb\x7e\x23\x22\x9e\x6d\x97\xff\xd4\xc8\xe6\x68\x23\x9d"
      "\x79\xfe\xb3\x07\xf2\x9f\x45\xc4\xe9\xe2\x67\xbe\xff\xad\x35\xb6\x5f\x7b"
      "\xa8\x2c\xff\xb0\x79\x1e\x25\xff\xef\xb5\xe4\xff\xfd\x35\xb6\xdf\x73\xfe"
      "\xaf\xaf\xb1\x01\x00\x00\x00\x00\x00\x00\xa8\x90\x3b\x27\x22\xe2\x95\x76"
      "\x7f\xff\xcb\x96\xd6\xff\x44\x9b\xf5\x3f\xc3\x11\x71\x7c\x1d\xda\x5f\xf9"
      "\xef\x7f\xd9\xdd\x75\x68\x06\x68\xe3\xde\x89\x88\xd7\xdb\xae\xff\xcd\x9a"
      "\x4f\x19\xed\x2b\x4a\x4f\x34\xd6\x03\x0c\xa4\xb3\xe7\xeb\x33\x87\x22\xe2"
      "\xc9\x88\x38\x10\x03\x3b\xf2\xf2\x44\x97\x36\x0e\x7e\xb1\xf7\xab\x4e\x75"
      "\xb5\x62\xed\x5f\xf3\x91\xb7\xdf\x5c\x0b\x58\xf4\xe3\x6e\xff\x8e\x07\x5f"
      "\x33\x3d\x35\x37\xf5\x28\xc7\x0c\x2c\xba\x77\x23\xe2\xb9\xb6\xeb\x7f\xd3"
      "\xd2\xf8\x9f\xda\x8c\xff\xf9\xef\x83\x2b\x3d\xb6\xb1\xf7\xa5\xdb\xa7\x3b"
      "\xd5\xad\x9c\x7f\x60\xa3\x2c\x7c\x13\xb1\xbf\xed\xf8\xff\xff\x9d\x2b\x52"
      "\xf7\xfb\x73\x8c\x37\xce\x07\xc6\x9b\x67\x05\xcb\x3d\xff\xc9\xad\x1f\x3a"
      "\xb5\x2f\xff\x50\x9e\x7c\xfc\xdf\xd5\x3d\xff\xa3\xa9\xf5\x7e\x3d\xb3\xab"
      "\x6f\xe3\xf0\x7c\xff\x42\xa7\xba\xb5\x9e\xff\x0f\xa6\x77\x1a\xb7\x9c\x19"
      "\x2c\xf6\x7d\x3c\x35\x37\x77\x75\x22\x62\x30\x9d\x5c\xbe\x7f\x72\xf5\x7d"
      "\x86\xed\xa8\x99\x87\x66\x5e\xf2\xfc\x1f\x78\xb1\xfb\xfc\x5f\xbb\xf3\xff"
      "\x9d\xab\x58\x92\xff\xf4\xbf\xc3\x7f\x74\xaa\x33\xfe\x43\x79\xf2\xfc\x4f"
      "\xaf\x6a\xfc\x5f\xfd\xc6\xe4\xed\xd1\x1f\x3b\xb5\xdf\xdb\xf8\x7f\xa4\x31"
      "\xa6\x1f\x28\xf6\x98\xff\x83\x2e\xf2\x93\xdf\x1e\x03\x5a\x76\x57\x01\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\xe0\x71\x94\x45\xc4\xee\x48\xd9\xd8\xd2\x76\x96\x8d"
      "\x8d\x45\x0c\x47\xc4\x53\xb1\x2b\xab\x5f\x9e\x9d\x7b\xf9\xec\xe5\x0f\x2f"
      "\x4d\xe7\x75\x8d\xef\xff\xcf\x9a\xdf\xf4\x3b\xb2\x58\x4e\xcd\xef\xff\x1f"
      "\x6d\x29\x4f\x3e\x54\x3e\x1c\x11\x7b\x22\xe2\xcb\xbe\x9d\x8d\xf2\xd8\x99"
      "\xcb\xf5\xe9\xb2\x0f\x1e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\xb6\x88\xe1\x0e\xd7\xff\xe7\xfe\xec\xeb\xfa\xd2\x37\x36\xa7"
      "\x87\xc0\x86\xea\x2f\xbb\x03\x40\x69\xe4\x1f\xaa\x4b\xfe\xa1\xba\xe4\x1f"
      "\x2a\xe9\x56\xc8\x3f\x54\x9a\xfc\x43\x75\xc9\x3f\x54\x97\xfc\x43\x75\xc9"
      "\x3f\x54\x97\xfc\x03\x00\x00\x00\x00\xc0\xb6\xb2\xe7\x85\x3b\xbf\xa5\x88"
      "\xb8\xfe\xda\xce\xc6\x23\x37\x58\xd4\x0d\x94\xda\x33\x60\xa3\x65\x65\x77"
      "\x00\x28\x4d\xf7\x5b\xfc\x00\xdb\x99\xa5\x3f\x50\x5d\x3e\xe3\x03\x69\x85"
      "\xfa\xa1\x35\xbf\x12\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x58\x2f\xfb"
      "\xf7\xb9\xfe\x1f\xaa\xca\xf5\xff\x50\x5d\xae\xff\x87\xea\x72\xfd\x3f\x54"
      "\xd7\xda\x3f\xe3\x7f\xbf\xae\xfd\x00\xca\xe3\xfa\x7f\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\xd8\xfa\x66\xe7\xaf\x5d\x98\xaa\xd7\x67\xae\x3e\x7e"
      "\x1b\x59\x44\x6c\x81\x6e\x6c\x97\x8d\x81\xad\xd1\x0d\x1b\x9b\xb8\x31\x14"
      "\x9d\x9f\x53\xf6\x6f\x26\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\xa0\xe9\xbf\x00\x00\x00\xff\xff\x80\x46\x20\x5d",
      1421);
  syz_mount_image(0x20000580, 0x200000c0, 0x14044, 0x20000000, 1, 0x58d,
                  0x20000b40);
  memcpy((void*)0x20000100, "./file1\000", 8);
  syscall(__NR_chmod, 0x20000100ul, 0x140ul);
  return 0;
}
